//+------------------------------------------------------------------+
//|                                                 FilterSignal.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 2
extern int           Len               = 15;
extern int           HistoryBars       = 500;
extern double        SignalLevel       = 6;
extern bool          UseRoundLevels    = true;
extern bool          UseAlerts         = true;

double SignUp[];
double SignDn[];
double IndBufUp[];
double IndBufDn[];

double LastBuyLevel, LastSellLevel;
datetime LastSignalTime = 0;

//=====================================================
//
//=====================================================
int OnInit()
  {
   IndicatorBuffers(4);
   SetIndexBuffer(0, SignUp);
   SetIndexBuffer(1, SignDn);
   SetIndexBuffer(2, IndBufUp);
   SetIndexBuffer(3, IndBufDn);
   
   SetIndexStyle(0, DRAW_ARROW,EMPTY,1,clrGreen);
   SetIndexStyle(1, DRAW_ARROW,EMPTY,1,clrRed);
   
   SetIndexLabel(0, "SignalUP");
   SetIndexLabel(1, "SignalDN");
   
   SetIndexArrow(0,233);
   SetIndexArrow(1,234);
   return(INIT_SUCCEEDED);
  }
  
//=====================================================
//
//=====================================================
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
{
   
   double up, dn;
   int indexUp=0, indexDn=0;
   bool  condRL=false;
   //int digitHi, digitLo;
   string kruglash = "";
   //double mult = 1;
   bool inZone = false;
   
   int    limit,  counted_bars = IndicatorCounted();
   if(counted_bars < 0) 
   return(-1);
   
   //if(Digits == 5 || Digits == 4) mult = 100;
   //if(Digits == 3 || Digits == 2) mult = 1;

   limit = HistoryBars;
   //Print("  limit = ", limit);
   if(Bars < HistoryBars + Len) 
   {
         Print("  .  Bars = ", Bars);
         return(0);
   }
   
   for(int i = limit; i >=0; i--)
   {
      IndBufUp[i] = iCustom(NULL,0, "88_filter", Len, HistoryBars, SignalLevel, 0,i);
      IndBufDn[i] = iCustom(NULL,0, "88_filter", Len, HistoryBars, SignalLevel, 1,i);
   }
   for(int i = limit; i >=0; i--)
   {
      up = IndBufUp[i];
      dn = IndBufDn[i];
      
      if(up>dn) LastSellLevel = 0;
      if(dn>up) LastBuyLevel = 0;
      
      //------------------  BUY --------------------------------
      if(
               LastBuyLevel != 0
            && High[i] > LastBuyLevel
           )
           {
               LastBuyLevel = 0;
                        // --------------------------   
                        //  2-      
                        /*
                        digitHi = (int)(High[indexUp]*mult);
                        digitHi = digitHi - (digitHi/10)*10;
                        
                        digitLo = (int)(Low[indexUp]*mult);
                        digitLo = digitLo - (digitLo/10)*10;
                        
                        if(digitHi !=  digitLo )
                            condRL = true; else condRL = false;     
                        */
                        condRL =CheckRoundLevel(indexUp);  
                        if(condRL) kruglash = " + "; else kruglash = "";
                        /*
                        if(i==128)
                        Print("  digitHi = ", digitHi, "  digitLo = ", digitLo,"  indexUp = ", indexUp,"  mult = ", mult);
                        */
                        
                        // --------------------------     
               
               
                        inZone = CheckZone(indexUp);
               
               if(condRL || !UseRoundLevels)
                {
                  SignUp[i] = Low[i] - Point*50;
               
                  if(Time[0] > LastSignalTime && i == 0 && UseAlerts)
                  {
                     LastSignalTime = Time[0];
                     Alert("   " + Symbol() + " " + IntegerToString(Period()) + kruglash); 
                     Print("   " + Symbol() + " " + IntegerToString(Period()) + kruglash); 
                  }
               }
               
           } 
         //------------------  SELL --------------------------------  
         if(
               LastSellLevel != 0
            && Low[i] < LastSellLevel
           )
           {
               LastSellLevel = 0;
                
                        // -------------------------------------  
                        //  2-   
                        /*
                        digitHi = (int)(High[indexDn]*mult);
                        digitHi = digitHi - (digitHi/10)*10;
                        
                        digitLo = (int)(Low[indexDn]*mult);
                        digitLo = digitLo - (digitLo/10)*10;
                        
                        if(digitHi !=  digitLo )
                            condRL = true; else condRL = false; 
                        */    
                        condRL =CheckRoundLevel(indexDn);      
               
                        if(condRL) kruglash = " + "; else kruglash = ""; 
                        
                        inZone = CheckZone(indexDn);
              
               if(condRL || !UseRoundLevels)
               {
                  SignDn[i] = High[i] + Point*50;
               
                  if(Time[0] > LastSignalTime && i==0 && UseAlerts)
                  {
                     LastSignalTime = Time[0];
                     Alert("   " + Symbol() + " " + IntegerToString(Period())  + kruglash); 
                     Print("   " + Symbol() + " " + IntegerToString(Period())  + kruglash); 
                  }
               }
           }   
      
      if(      up > dn 
            && up > SignalLevel
            && Close[i] < Open[i]
        )
        {LastBuyLevel = Open[i]; indexUp = i;}  
      
      if(      dn > up 
            && dn > SignalLevel
            && Close[i] > Open[i]
        )
        {LastSellLevel = Open[i];  indexDn = i;}
  
   }
    return(rates_total);
}
//=====================================================
//    CheckZone
//=====================================================
bool CheckZone(int index)
{
    bool val =false;
    return(val);
}
//=====================================================
//    CheckRoundLevel
//=====================================================
bool CheckRoundLevel(int index)
{
      
   int digitHi, digitLo;
   double mult = 1; 
   bool val =false;
   
   if(Digits == 5 || Digits == 4) mult = 100;
   if(Digits == 3 || Digits == 2) mult = 1;   
      
      digitHi = (int)(High[index]*mult);
      digitHi = digitHi - (digitHi/10)*10;
                        
      digitLo = (int)(Low[index]*mult);
      digitLo = digitLo - (digitLo/10)*10;
                        
       if(digitHi !=  digitLo ) val = true; else val = false;
       return(val);

}

